diff --git a/TAGS b/TAGS
index 40e1640..c22cb0d 100644
--- a/TAGS
+++ b/TAGS
@@ -523,123 +2792,137 @@ impl<'a, C: PanelContent> Panel<'a, C> {Panel40,1432
 impl<C: PanelContent> Widget for Panel<'_, C> {Panel50,1637
     fn render(self, area: Rect, buf: &mut Buffer) {render51,1685
 
-src/ui/app.rs,6779
-pub struct DrillState {DrillState26,738
-    pub records: Rc<Vec<(crate::model::cell::CellKey, crate::model::cell::CellValue)>>,records28,845
-    pub pending_edits: std::collections::HashMap<(usize, String), String>,pending_edits31,1070
-pub struct MinibufferConfig {MinibufferConfig37,1299
-    pub buffer_key: &'static str,buffer_key38,1329
-    pub prompt: String,prompt39,1363
-    pub color: Color,color40,1387
-pub enum AppMode {AppMode44,1447
-    Normal,Normal45,1466
-    Editing {Editing46,1478
-    FormulaEdit {FormulaEdit49,1534
-    FormulaPanel,FormulaPanel52,1594
-    CategoryPanel,CategoryPanel53,1612
-    CategoryAdd {CategoryAdd55,1704
-    ItemAdd {ItemAdd59,1842
-    ViewPanel,ViewPanel63,1924
-    TileSelect,TileSelect64,1939
-    ImportWizard,ImportWizard65,1955
-    ExportPrompt {ExportPrompt66,1973
-    CommandMode {CommandMode70,2069
-    Help,Help73,2129
-    Quit,Quit74,2139
-impl AppMode {AppMode77,2152
-    pub fn minibuffer(&self) -> Option<&MinibufferConfig> {minibuffer79,2240
-    pub fn editing() -> Self {editing91,2658
-    pub fn formula_edit() -> Self {formula_edit101,2899
-    pub fn command_mode() -> Self {command_mode111,3154
-    pub fn category_add() -> Self {category_add121,3403
-    pub fn item_add(category: String) -> Self {item_add131,3666
-    pub fn export_prompt() -> Self {export_prompt143,3987
-pub struct App {App154,4251
-    pub model: Model,model155,4268
-    pub file_path: Option<PathBuf>,file_path156,4290
-    pub mode: AppMode,mode157,4326
-    pub status_msg: String,status_msg158,4349
-    pub wizard: Option<ImportWizard>,wizard159,4377
-    pub last_autosave: Instant,last_autosave160,4415
-    pub search_query: String,search_query161,4447
-    pub search_mode: bool,search_mode162,4477
-    pub formula_panel_open: bool,formula_panel_open163,4504
-    pub category_panel_open: bool,category_panel_open164,4538
-    pub view_panel_open: bool,view_panel_open165,4573
-    pub cat_panel_cursor: usize,cat_panel_cursor166,4604
-    pub view_panel_cursor: usize,view_panel_cursor167,4637
-    pub formula_cursor: usize,formula_cursor168,4671
-    pub dirty: bool,dirty169,4702
-    pub yanked: Option<CellValue>,yanked171,4763
-    pub tile_cat_idx: usize,tile_cat_idx173,4863
-    pub view_back_stack: Vec<String>,view_back_stack176,5015
-    pub view_forward_stack: Vec<String>,view_forward_stack178,5133
-    pub drill_state: Option<DrillState>,drill_state183,5455
-    pub help_page: usize,help_page185,5553
-    pub term_width: u16,term_width187,5643
-    pub term_height: u16,term_height188,5668
-    pub expanded_cats: std::collections::HashSet<String>,expanded_cats190,5755
-    pub buffers: HashMap<String, String>,buffers192,5861
-    pub transient_keymap: Option<Arc<Keymap>>,transient_keymap194,5988
-    pub layout: GridLayout,layout197,6165
-    keymap_set: KeymapSet,keymap_set198,6193
-impl App {App201,6223
-    pub fn new(mut model: Model, file_path: Option<PathBuf>) -> Self {new202,6234
-    pub fn rebuild_layout(&mut self) {rebuild_layout250,8084
-    pub fn cmd_context(&self, key: KeyCode, _mods: KeyModifiers) -> CmdContext<'_> {cmd_context265,8683
-    pub fn apply_effects(&mut self, effects: Vec<Box<dyn super::effect::Effect>>) {apply_effects327,11324
-    pub fn is_empty_model(&self) -> bool {is_empty_model336,11688
-    pub fn handle_key(&mut self, key: KeyEvent) -> Result<()> {handle_key348,12049
-    pub fn autosave_if_needed(&mut self) {autosave_if_needed376,13064
-    pub fn start_import_wizard(&mut self, json: serde_json::Value) {start_import_wizard385,13439
-    pub fn hint_text(&self) -> &'static str {hint_text391,13668
-mod tests {tests421,15079
-    fn two_col_model() -> App {two_col_model425,15139
-    fn run_cmd(app: &mut App, cmd: &dyn crate::command::cmd::Cmd) {run_cmd437,15626
-    fn enter_advance_cmd(app: &App) -> crate::command::cmd::navigation::EnterAdvance {enter_advance_cmd444,15867
-    fn enter_advance_moves_down_within_column() {enter_advance_moves_down_within_column461,16419
-    fn enter_advance_wraps_to_top_of_next_column() {enter_advance_wraps_to_top_of_next_column470,16720
-    fn enter_advance_stays_at_bottom_right() {enter_advance_stays_at_bottom_right480,17088
-    fn import_command_switches_to_import_wizard_mode() {import_command_switches_to_import_wizard_mode489,17386
-    fn execute_import_command_leaves_mode_as_import_wizard() {execute_import_command_leaves_mode_as_import_wizard502,17921
-    fn command_mode_typing_appends_to_buffer() {command_mode_typing_appends_to_buffer514,18395
-    fn col_offset_scrolls_when_cursor_moves_past_visible_columns() {col_offset_scrolls_when_cursor_moves_past_visible_columns530,19027
-    fn home_jumps_to_first_col() {home_jumps_to_first_col577,21043
-    fn end_jumps_to_last_col() {end_jumps_to_last_col586,21349
-    fn page_down_scrolls_by_three_quarters_visible() {page_down_scrolls_by_three_quarters_visible595,21652
-    fn page_up_scrolls_backward() {page_up_scrolls_backward618,22468
-    fn jump_last_row_scrolls_with_small_terminal() {jump_last_row_scrolls_with_small_terminal634,22970
-    fn ctrl_d_scrolls_viewport_with_small_terminal() {ctrl_d_scrolls_viewport_with_small_terminal660,24015
-    fn tab_in_edit_mode_commits_and_moves_right() {tab_in_edit_mode_commits_and_moves_right687,25111
-    fn command_mode_buffer_cleared_on_reentry() {command_mode_buffer_cleared_on_reentry714,26113
-    fn fresh_model_is_empty() {fresh_model_is_empty735,27114
-    fn model_with_user_category_is_not_empty() {model_with_user_category_is_not_empty744,27355
-    fn help_page_next_advances_page() {help_page_next_advances_page757,27842
-    fn help_page_prev_goes_back() {help_page_prev_goes_back768,28187
-    fn help_page_clamps_at_zero() {help_page_clamps_at_zero779,28528
-    fn help_page_clamps_at_max() {help_page_clamps_at_max790,28869
-    fn help_q_returns_to_normal() {help_q_returns_to_normal809,29527
-    fn help_esc_returns_to_normal() {help_esc_returns_to_normal822,29895
-    fn help_colon_enters_command_mode() {help_colon_enters_command_mode835,30261
-    fn add_item_to_nonexistent_category_sets_status() {add_item_to_nonexistent_category_sets_status851,30859
-    fn add_formula_with_bad_syntax_sets_status() {add_formula_with_bad_syntax_sets_status867,31374
-    fn tile_axis_change_stays_in_tile_select() {tile_axis_change_stays_in_tile_select885,32045
-    fn category_panel_colon_enters_command_mode() {category_panel_colon_enters_command_mode907,32862
-    fn view_panel_colon_enters_command_mode() {view_panel_colon_enters_command_mode921,33300
-    fn tile_select_colon_enters_command_mode() {tile_select_colon_enters_command_mode935,33726
+src/ui/app.rs,7956
+pub struct ViewFrame {ViewFrame25,683
+    pub view_name: String,view_name26,706
+    pub mode: AppMode,mode27,733
+pub struct DrillState {DrillState33,902
+    pub records: Rc<Vec<(crate::model::cell::CellKey, crate::model::cell::CellValue)>>,records35,1009
+    pub pending_edits: std::collections::HashMap<(usize, String), String>,pending_edits38,1234
+pub struct MinibufferConfig {MinibufferConfig44,1463
+    pub buffer_key: &'static str,buffer_key45,1493
+    pub prompt: String,prompt46,1527
+    pub color: Color,color47,1551
+pub enum AppMode {AppMode51,1611
+    Normal,Normal52,1630
+    Editing {Editing53,1642
+    FormulaEdit {FormulaEdit56,1698
+    FormulaPanel,FormulaPanel59,1758
+    CategoryPanel,CategoryPanel60,1776
+    CategoryAdd {CategoryAdd62,1868
+    ItemAdd {ItemAdd66,2006
+    ViewPanel,ViewPanel70,2088
+    TileSelect,TileSelect71,2103
+    ImportWizard,ImportWizard72,2119
+    ExportPrompt {ExportPrompt73,2137
+    CommandMode {CommandMode77,2233
+    Help,Help80,2293
+    Quit,Quit81,2303
+    RecordsNormal,RecordsNormal83,2395
+    RecordsEditing {RecordsEditing85,2497
+impl AppMode {AppMode90,2563
+    pub fn minibuffer(&self) -> Option<&MinibufferConfig> {minibuffer92,2651
+    pub fn is_editing(&self) -> bool {is_editing106,3180
+    pub fn editing() -> Self {editing110,3301
+    pub fn records_editing() -> Self {records_editing120,3542
+    pub fn is_records(&self) -> bool {is_records131,3853
+    pub fn formula_edit() -> Self {formula_edit135,3973
+    pub fn command_mode() -> Self {command_mode145,4228
+    pub fn category_add() -> Self {category_add155,4477
+    pub fn item_add(category: String) -> Self {item_add165,4740
+    pub fn export_prompt() -> Self {export_prompt177,5061
+pub struct App {App188,5325
+    pub model: Model,model189,5342
+    pub file_path: Option<PathBuf>,file_path190,5364
+    pub mode: AppMode,mode191,5400
+    pub status_msg: String,status_msg192,5423
+    pub wizard: Option<ImportWizard>,wizard193,5451
+    pub last_autosave: Instant,last_autosave194,5489
+    pub search_query: String,search_query195,5521
+    pub search_mode: bool,search_mode196,5551
+    pub formula_panel_open: bool,formula_panel_open197,5578
+    pub category_panel_open: bool,category_panel_open198,5612
+    pub view_panel_open: bool,view_panel_open199,5647
+    pub cat_panel_cursor: usize,cat_panel_cursor200,5678
+    pub view_panel_cursor: usize,view_panel_cursor201,5711
+    pub formula_cursor: usize,formula_cursor202,5745
+    pub dirty: bool,dirty203,5776
+    pub yanked: Option<CellValue>,yanked205,5837
+    pub tile_cat_idx: usize,tile_cat_idx207,5937
+    pub view_back_stack: Vec<ViewFrame>,view_back_stack210,6089
+    pub view_forward_stack: Vec<ViewFrame>,view_forward_stack212,6210
+    pub drill_state: Option<DrillState>,drill_state217,6535
+    pub help_page: usize,help_page219,6633
+    pub term_width: u16,term_width221,6723
+    pub term_height: u16,term_height222,6748
+    pub expanded_cats: std::collections::HashSet<String>,expanded_cats224,6835
+    pub buffers: HashMap<String, String>,buffers226,6941
+    pub transient_keymap: Option<Arc<Keymap>>,transient_keymap228,7068
+    pub layout: GridLayout,layout231,7245
+    keymap_set: KeymapSet,keymap_set232,7273
+impl App {App235,7303
+    pub fn new(mut model: Model, file_path: Option<PathBuf>) -> Self {new236,7314
+    pub fn rebuild_layout(&mut self) {rebuild_layout284,9164
+    pub fn cmd_context(&self, key: KeyCode, _mods: KeyModifiers) -> CmdContext<'_> {cmd_context299,9763
+    pub fn apply_effects(&mut self, effects: Vec<Box<dyn super::effect::Effect>>) {apply_effects362,12461
+    pub fn is_empty_model(&self) -> bool {is_empty_model371,12825
+    pub fn handle_key(&mut self, key: KeyEvent) -> Result<()> {handle_key383,13186
+    pub fn autosave_if_needed(&mut self) {autosave_if_needed411,14201
+    pub fn start_import_wizard(&mut self, json: serde_json::Value) {start_import_wizard422,14580
+    pub fn hint_text(&self) -> &'static str {hint_text428,14809
+mod tests {tests463,16417
+    fn two_col_model() -> App {two_col_model467,16477
+    fn run_cmd(app: &mut App, cmd: &dyn crate::command::cmd::Cmd) {run_cmd479,16964
+    fn enter_advance_cmd(app: &App) -> crate::command::cmd::navigation::EnterAdvance {enter_advance_cmd486,17205
+    fn enter_advance_moves_down_within_column() {enter_advance_moves_down_within_column503,17757
+    fn enter_advance_wraps_to_top_of_next_column() {enter_advance_wraps_to_top_of_next_column512,18058
+    fn enter_advance_stays_at_bottom_right() {enter_advance_stays_at_bottom_right522,18426
+    fn import_command_switches_to_import_wizard_mode() {import_command_switches_to_import_wizard_mode531,18724
+    fn execute_import_command_leaves_mode_as_import_wizard() {execute_import_command_leaves_mode_as_import_wizard544,19259
+    fn command_mode_typing_appends_to_buffer() {command_mode_typing_appends_to_buffer556,19733
+    fn col_offset_scrolls_when_cursor_moves_past_visible_columns() {col_offset_scrolls_when_cursor_moves_past_visible_columns572,20365
+    fn home_jumps_to_first_col() {home_jumps_to_first_col619,22381
+    fn end_jumps_to_last_col() {end_jumps_to_last_col628,22687
+    fn page_down_scrolls_by_three_quarters_visible() {page_down_scrolls_by_three_quarters_visible637,22990
+    fn page_up_scrolls_backward() {page_up_scrolls_backward660,23805
+    fn jump_last_row_scrolls_with_small_terminal() {jump_last_row_scrolls_with_small_terminal676,24306
+    fn ctrl_d_scrolls_viewport_with_small_terminal() {ctrl_d_scrolls_viewport_with_small_terminal702,25350
+    fn tab_in_edit_mode_commits_and_moves_right() {tab_in_edit_mode_commits_and_moves_right729,26445
+    fn entering_records_mode_sorts_existing_data() {entering_records_mode_sorts_existing_data759,27674
+    fn add_record_row_in_empty_records_view_creates_first_row() {add_record_row_in_empty_records_view_creates_first_row795,29115
+    fn edit_record_row_in_blank_model_persists_value() {edit_record_row_in_blank_model_persists_value826,30356
+    fn records_model_with_two_rows() -> App {records_model_with_two_rows865,32017
+    fn tab_on_bottom_right_of_records_inserts_below() {tab_on_bottom_right_of_records_inserts_below920,33962
+    fn drill_edit_is_staged_until_view_back() {drill_edit_is_staged_until_view_back958,35393
+    fn blanking_records_category_does_not_create_empty_item() {blanking_records_category_does_not_create_empty_item1017,37806
+    fn command_mode_buffer_cleared_on_reentry() {command_mode_buffer_cleared_on_reentry1047,38887
+    fn fresh_model_is_empty() {fresh_model_is_empty1068,39888
+    fn model_with_user_category_is_not_empty() {model_with_user_category_is_not_empty1077,40129
+    fn help_page_next_advances_page() {help_page_next_advances_page1090,40616
+    fn help_page_prev_goes_back() {help_page_prev_goes_back1101,40961
+    fn help_page_clamps_at_zero() {help_page_clamps_at_zero1112,41302
+    fn help_page_clamps_at_max() {help_page_clamps_at_max1123,41643
+    fn help_q_returns_to_normal() {help_q_returns_to_normal1142,42301
+    fn help_esc_returns_to_normal() {help_esc_returns_to_normal1155,42669
+    fn help_colon_enters_command_mode() {help_colon_enters_command_mode1168,43035
+    fn add_item_to_nonexistent_category_sets_status() {add_item_to_nonexistent_category_sets_status1184,43633
+    fn add_formula_with_bad_syntax_sets_status() {add_formula_with_bad_syntax_sets_status1200,44148
+    fn tile_axis_change_stays_in_tile_select() {tile_axis_change_stays_in_tile_select1218,44819
+    fn category_panel_colon_enters_command_mode() {category_panel_colon_enters_command_mode1240,45636
+    fn view_panel_colon_enters_command_mode() {view_panel_colon_enters_command_mode1254,46074
+    fn tile_select_colon_enters_command_mode() {tile_select_colon_enters_command_mode1268,46500
 
-src/lib.rs,249
+src/lib.rs,221
 pub mod command;command1,0
 pub mod draw;draw2,17
 pub mod format;format3,31
-pub mod formula;formula4,47
-pub mod import;import5,64
-pub mod model;model6,80
-pub mod persistence;persistence7,95
-pub mod ui;ui8,116
-pub mod view;view9,128
+pub mod import;import5,85
+pub mod model;model6,101
+pub mod persistence;persistence7,116
+pub mod ui;ui8,137
+pub mod view;view9,149
 
-src/draw.rs,1274
+src/draw.rs,1275
 struct TuiContext<'a> {TuiContext31,881
     terminal: Terminal<CrosstermBackend<&'a mut Stdout>>,terminal32,905
 impl<'a> TuiContext<'a> {TuiContext35,966
@@ -651,182 +2934,72 @@ fn fill_line(left: String, right: &str, width: u16) -> String {fill_line96,265
 fn centered_popup(area: Rect, width: u16, height: u16) -> Rect {centered_popup101,2842
 fn draw_popup_frame(f: &mut Frame, popup: Rect, title: &str, border_color: Color) -> Rect {draw_popup_frame109,3119
 fn mode_name(mode: &AppMode) -> &'static str {mode_name120,3474
-fn mode_style(mode: &AppMode) -> Style {mode_style139,4163
-fn draw(f: &mut Frame, app: &App) {draw148,4562
-fn draw_title(f: &mut Frame, area: Rect, app: &App) {draw_title186,5907
-fn draw_content(f: &mut Frame, area: Rect, app: &App) {draw_content209,6613
-fn draw_tile_bar(f: &mut Frame, area: Rect, app: &App) {draw_tile_bar268,8484
-fn draw_bottom_bar(f: &mut Frame, area: Rect, app: &App) {draw_bottom_bar272,8626
-fn draw_status(f: &mut Frame, area: Rect, app: &App) {draw_status294,9251
-fn draw_welcome(f: &mut Frame, area: Rect) {draw_welcome316,9932
-
-src/formula/mod.rs,49
-pub mod ast;ast1,0
-pub mod parser;parser2,13
-
-src/formula/ast.rs,1076
-pub enum AggFunc {AggFunc4,86
-    Sum,Sum5,105
-    Avg,Avg6,114
-    Min,Min7,123
-    Max,Max8,132
-    Count,Count9,141
-pub enum BinOp {BinOp17,488
-    Add,Add18,505
-    Sub,Sub19,514
-    Mul,Mul20,523
-    Div,Div21,532
-    Pow,Pow22,541
-    Eq,Eq23,550
-    Ne,Ne24,558
-    Lt,Lt25,566
-    Gt,Gt26,574
-    Le,Le27,582
-    Ge,Ge28,590
-pub struct Filter {Filter32,649
-    pub category: String,category33,669
-    pub item: String,item34,695
-pub enum Expr {Expr38,768
-    Number(f64),Number39,784
-    Ref(String),Ref40,801
-    BinOp(BinOp, Box<Expr>, Box<Expr>),BinOp41,818
-    UnaryMinus(Box<Expr>),UnaryMinus42,858
-    Agg(AggFunc, Box<Expr>, Option<Filter>),Agg43,885
-    If(Box<Expr>, Box<Expr>, Box<Expr>),If44,930
-pub struct Formula {Formula48,1022
-    pub raw: String,raw50,1104
-    pub target: String,target52,1194
-    pub target_category: String,target_category54,1266
-    pub expr: Expr,expr56,1334
-    pub filter: Option<Filter>,filter58,1384
-impl Formula {Formula61,1419
-    pub fn new(new62,1434
-
-src/formula/parser.rs,4182
-pub fn parse_formula(raw: &str, target_category: &str) -> Result<Formula> {parse_formula7,201
-fn split_where(s: &str) -> (&str, Option<&str>) {split_where26,820
-fn unquote(s: &str) -> String {unquote64,1950
-fn parse_where(s: &str) -> Result<Filter> {parse_where73,2180
-pub fn parse_expr(s: &str) -> Result<Expr> {parse_expr84,2576
-enum Token {Token98,2928
-    Number(f64),Number99,2941
-    Ident(String),Ident100,2958
-    Str(String),Str101,2977
-    Plus,Plus102,2994
-    Minus,Minus103,3004
-    Star,Star104,3015
-    Slash,Slash105,3025
-    Caret,Caret106,3036
-    LParen,LParen107,3047
-    RParen,RParen108,3059
-    Comma,Comma109,3071
-    Eq,Eq110,3082
-    Ne,Ne111,3090
-    Lt,Lt112,3098
-    Gt,Gt113,3106
-    Le,Le114,3114
-    Ge,Ge115,3122
-fn tokenize(s: &str) -> Result<Vec<Token>> {tokenize118,3133
-fn parse_add_sub(tokens: &[Token], pos: &mut usize) -> Result<Expr> {parse_add_sub277,8753
-fn parse_mul_div(tokens: &[Token], pos: &mut usize) -> Result<Expr> {parse_mul_div292,9211
-fn parse_pow(tokens: &[Token], pos: &mut usize) -> Result<Expr> {parse_pow307,9661
-fn parse_unary(tokens: &[Token], pos: &mut usize) -> Result<Expr> {parse_unary317,9991
-fn parse_primary(tokens: &[Token], pos: &mut usize) -> Result<Expr> {parse_primary326,10274
-fn parse_comparison(tokens: &[Token], pos: &mut usize) -> Result<Expr> {parse_comparison441,15475
-mod tests {tests461,16050
-    fn parse_simple_subtraction() {parse_simple_subtraction466,16153
-    fn parse_where_clause() {parse_where_clause474,16434
-    fn parse_sum_aggregation() {parse_sum_aggregation483,16753
-    fn parse_avg_aggregation() {parse_avg_aggregation489,16942
-    fn parse_if_expression() {parse_if_expression495,17129
-    fn parse_numeric_literal() {parse_numeric_literal501,17326
-    fn parse_chained_arithmetic() {parse_chained_arithmetic507,17519
-    fn parse_missing_equals_returns_error() {parse_missing_equals_returns_error512,17638
-    fn parse_min_aggregation() {parse_min_aggregation519,17949
-    fn parse_max_aggregation() {parse_max_aggregation525,18135
-    fn parse_count_aggregation() {parse_count_aggregation531,18321
-    fn parse_sum_with_top_level_where_works() {parse_sum_with_top_level_where_works539,18667
-    fn parse_sum_with_inline_where_filter() {parse_sum_with_inline_where_filter550,19190
-    fn parse_if_with_comparison_operators() {parse_if_with_comparison_operators564,19852
-    fn parse_where_with_quoted_string_inside_expression() {parse_where_with_quoted_string_inside_expression585,20774
-    fn parse_power_operator() {parse_power_operator595,21275
-    fn parse_unary_minus() {parse_unary_minus603,21640
-    fn parse_multiplication() {parse_multiplication611,21964
-    fn parse_division() {parse_division617,22152
-    fn parse_nested_parens() {parse_nested_parens625,22493
-    fn parse_aggregate_name_without_parens_is_ref() {parse_aggregate_name_without_parens_is_ref633,22788
-    fn parse_if_without_parens_is_ref() {parse_if_without_parens_is_ref643,23182
-    fn parse_quoted_string_in_where() {parse_quoted_string_in_where656,23725
-    fn parse_unexpected_token_error() {parse_unexpected_token_error666,24205
-    fn parse_unexpected_character_error() {parse_unexpected_character_error673,24393
-    fn parse_empty_expression_error() {parse_empty_expression_error679,24537
-    fn tokenizer_breaks_at_where_keyword() {tokenizer_breaks_at_where_keyword685,24669
-    fn parse_multi_word_identifier() {parse_multi_word_identifier695,25152
-    fn split_where_ignores_where_inside_quotes() {split_where_ignores_where_inside_quotes703,25485
-    fn pipe_quoted_identifier_in_expression() {pipe_quoted_identifier_in_expression713,25962
-    fn pipe_quoted_keyword_as_identifier() {pipe_quoted_keyword_as_identifier725,26463
-    fn pipe_quoted_identifier_with_special_chars() {pipe_quoted_identifier_with_special_chars737,26947
-    fn pipe_quoted_in_aggregate() {pipe_quoted_in_aggregate749,27477
-    fn pipe_quoted_in_where_filter_value() {pipe_quoted_in_where_filter_value759,27841
-    fn pipe_quoted_in_inline_where() {pipe_quoted_in_inline_where766,28091
+fn mode_style(mode: &AppMode) -> Style {mode_style141,4268
+fn draw(f: &mut Frame, app: &App) {draw152,4723
+fn draw_title(f: &mut Frame, area: Rect, app: &App) {draw_title191,6064
+fn draw_content(f: &mut Frame, area: Rect, app: &App) {draw_content214,6770
+fn draw_tile_bar(f: &mut Frame, area: Rect, app: &App) {draw_tile_bar273,8641
+fn draw_bottom_bar(f: &mut Frame, area: Rect, app: &App) {draw_bottom_bar277,8783
+fn draw_status(f: &mut Frame, area: Rect, app: &App) {draw_status299,9408
+fn draw_welcome(f: &mut Frame, area: Rect) {draw_welcome321,10089
 
 src/persistence/mod.rs,4159
 struct ImprovParser;ImprovParser18,466
 fn is_bare_name(name: &str) -> bool {is_bare_name23,707
 fn escape_pipe(s: &str) -> String {escape_pipe33,1040
-    fn text_value_is_empty_string() {text_value_is_empty_string1290,46916
-    fn text_value_with_newline() {text_value_with_newline1306,47424
-    fn text_value_looks_like_number() {text_value_looks_like_number1322,47956
-    fn text_value_with_hash_prefix() {text_value_with_hash_prefix1338,48488
-    fn item_name_with_brackets_misinterpreted_as_group() {item_name_with_brackets_misinterpreted_as_group1354,49030
-    fn category_name_with_comma_space_in_data() {category_name_with_comma_space_in_data1373,49788
-    fn item_name_with_equals_sign_in_data() {item_name_with_equals_sign_in_data1394,50558
-    fn view_name_with_parentheses() {view_name_with_parentheses1415,51280
-    fn multiple_tricky_text_cells() {multiple_tricky_text_cells1431,51797
-mod parser_prop_tests {parser_prop_tests1468,53153
-    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord1474,53325
-    fn safe_ident() -> impl Strategy<Value = String> {safe_ident1484,53606
-    fn tricky_text() -> impl Strategy<Value = String> {tricky_text1489,53764
-    fn cell_value() -> impl Strategy<Value = CellValue> {cell_value1506,54317
-    fn arbitrary_model() -> impl Strategy<Value = Model> {arbitrary_model1516,54677
-mod parser_edge_cases {parser_edge_cases1736,63478
-    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord1742,63659
-    fn backtick_in_category_name() {backtick_in_category_name1754,64039
-    fn item_name_with_both_equals_and_comma() {item_name_with_both_equals_and_comma1775,64738
-    fn hidden_item_with_slash_in_name() {hidden_item_with_slash_in_name1798,65621
-    fn collapsed_group_with_slash_in_name() {collapsed_group_with_slash_in_name1815,66239
-    fn view_name_ending_with_active_string() {view_name_ending_with_active_string1829,66703
-    fn group_name_with_brackets() {group_name_with_brackets1848,67484
-    fn item_in_group_where_item_has_brackets() {item_in_group_where_item_has_brackets1871,68294
-    fn parse_empty_string() {parse_empty_string1898,69358
-    fn parse_just_model_name() {parse_just_model_name1907,69603
-    fn parse_data_without_value() {parse_data_without_value1913,69757
-    fn parse_data_with_empty_coords() {parse_data_with_empty_coords1920,69989
-    fn parse_duplicate_categories() {parse_duplicate_categories1927,70223
-    fn parse_category_with_no_items() {parse_category_with_no_items1936,70592
-    fn number_negative_zero_roundtrips() {number_negative_zero_roundtrips1947,71110
-    fn number_very_large_roundtrips() {number_very_large_roundtrips1965,71788
-    fn number_very_small_roundtrips() {number_very_small_roundtrips1987,72512
-    fn number_pi_roundtrips() {number_pi_roundtrips2009,73242
-    fn model_name_with_leading_trailing_spaces() {model_name_with_leading_trailing_spaces2033,74115
-    fn category_name_with_trailing_spaces() {category_name_with_trailing_spaces2041,74406
-    fn data_line_with_extra_whitespace() {data_line_with_extra_whitespace2049,74714
-    fn three_categories_round_trip() {three_categories_round_trip2059,75254
-    fn text_value_with_backslash() {text_value_with_backslash2089,76386
-    fn text_value_with_backslash_n_literal() {text_value_with_backslash_n_literal2110,77096
-mod generator {generator2138,78240
-    fn load_grammar() -> HashMap<String, (RuleType, Expr)> {load_grammar2145,78454
-    struct Gen<'g> {Gen2161,79179
-        rules: &'g HashMap<String, (RuleType, Expr)>,rules2162,79200
-        choices: Vec<u8>,choices2163,79254
-        pos: usize,pos2164,79280
-    impl<'g> Gen<'g> {Gen2167,79307
-        fn new(rules: &'g HashMap<String, (RuleType, Expr)>, choices: Vec<u8>) -> Self {new2168,79330
-        fn pick(&mut self) -> u8 {pick2177,79593
-        fn emit(&mut self, expr: &Expr, out: &mut String) {emit2183,79750
-        fn generate(&mut self, rule_name: &str) -> String {generate2259,82798
-    pub fn improv_file() -> impl Strategy<Value = String> {improv_file2269,83149
-mod grammar_prop_tests {grammar_prop_tests2280,83509
+    fn text_value_is_empty_string() {text_value_is_empty_string1294,46932
+    fn text_value_with_newline() {text_value_with_newline1310,47440
+    fn text_value_looks_like_number() {text_value_looks_like_number1326,47972
+    fn text_value_with_hash_prefix() {text_value_with_hash_prefix1342,48504
+    fn item_name_with_brackets_misinterpreted_as_group() {item_name_with_brackets_misinterpreted_as_group1358,49046
+    fn category_name_with_comma_space_in_data() {category_name_with_comma_space_in_data1377,49804
+    fn item_name_with_equals_sign_in_data() {item_name_with_equals_sign_in_data1398,50574
+    fn view_name_with_parentheses() {view_name_with_parentheses1419,51296
+    fn multiple_tricky_text_cells() {multiple_tricky_text_cells1435,51813
+mod parser_prop_tests {parser_prop_tests1472,53169
+    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord1478,53341
+    fn safe_ident() -> impl Strategy<Value = String> {safe_ident1488,53622
+    fn tricky_text() -> impl Strategy<Value = String> {tricky_text1493,53780
+    fn cell_value() -> impl Strategy<Value = CellValue> {cell_value1510,54333
+    fn arbitrary_model() -> impl Strategy<Value = Model> {arbitrary_model1520,54693
+mod parser_edge_cases {parser_edge_cases1740,63494
+    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord1746,63675
+    fn backtick_in_category_name() {backtick_in_category_name1758,64055
+    fn item_name_with_both_equals_and_comma() {item_name_with_both_equals_and_comma1779,64754
+    fn hidden_item_with_slash_in_name() {hidden_item_with_slash_in_name1802,65637
+    fn collapsed_group_with_slash_in_name() {collapsed_group_with_slash_in_name1819,66255
+    fn view_name_ending_with_active_string() {view_name_ending_with_active_string1833,66719
+    fn group_name_with_brackets() {group_name_with_brackets1852,67500
+    fn item_in_group_where_item_has_brackets() {item_in_group_where_item_has_brackets1875,68310
+    fn parse_empty_string() {parse_empty_string1902,69374
+    fn parse_just_model_name() {parse_just_model_name1911,69619
+    fn parse_data_without_value() {parse_data_without_value1917,69773
+    fn parse_data_with_empty_coords() {parse_data_with_empty_coords1924,70005
+    fn parse_duplicate_categories() {parse_duplicate_categories1931,70239
+    fn parse_category_with_no_items() {parse_category_with_no_items1940,70608
+    fn number_negative_zero_roundtrips() {number_negative_zero_roundtrips1951,71126
+    fn number_very_large_roundtrips() {number_very_large_roundtrips1969,71804
+    fn number_very_small_roundtrips() {number_very_small_roundtrips1991,72528
+    fn number_pi_roundtrips() {number_pi_roundtrips2013,73258
+    fn model_name_with_leading_trailing_spaces() {model_name_with_leading_trailing_spaces2037,74131
+    fn category_name_with_trailing_spaces() {category_name_with_trailing_spaces2045,74422
+    fn data_line_with_extra_whitespace() {data_line_with_extra_whitespace2053,74730
+    fn three_categories_round_trip() {three_categories_round_trip2063,75270
+    fn text_value_with_backslash() {text_value_with_backslash2093,76402
+    fn text_value_with_backslash_n_literal() {text_value_with_backslash_n_literal2114,77112
+mod generator {generator2142,78256
+    fn load_grammar() -> HashMap<String, (RuleType, Expr)> {load_grammar2149,78470
+    struct Gen<'g> {Gen2165,79195
+        rules: &'g HashMap<String, (RuleType, Expr)>,rules2166,79216
+        choices: Vec<u8>,choices2167,79270
+        pos: usize,pos2168,79296
+    impl<'g> Gen<'g> {Gen2171,79323
+        fn new(rules: &'g HashMap<String, (RuleType, Expr)>, choices: Vec<u8>) -> Self {new2172,79346
+        fn pick(&mut self) -> u8 {pick2181,79609
+        fn emit(&mut self, expr: &Expr, out: &mut String) {emit2187,79766
+        fn generate(&mut self, rule_name: &str) -> String {generate2263,82824
+    pub fn improv_file() -> impl Strategy<Value = String> {improv_file2273,83175
+mod grammar_prop_tests {grammar_prop_tests2284,83535
 
 src/model/symbol.rs,879
 pub struct Symbol(u64);Symbol5,171
@@ -845,7 +3018,7 @@ mod tests {tests54,1534
     fn different_strings_different_ids() {different_strings_different_ids66,1766
     fn resolve_roundtrips() {resolve_roundtrips74,1964
 
-src/model/types.rs,10437
+src/model/types.rs,10549
 const MAX_CATEGORIES: usize = 12;MAX_CATEGORIES12,283
 pub struct Model {Model15,366
     pub name: String,name16,385
